"use strict";
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.cancelled = exports.takeLatest = exports.takeEvery = exports.workers = exports.saga = void 0;
var kea_1 = require("kea");
var effects_1 = require("redux-saga/effects");
var channel_1 = require("./channel");
var utils_1 = require("./utils");
var sagaIndex = 0;
function saga(input) {
    return function (_logic) {
        var logic = _logic;
        (0, utils_1.addGetAndFetch)(logic);
        var index = sagaIndex++;
        (0, kea_1.afterMount)(function () { return (0, channel_1.startSaga)(index, input.bind(logic)); })(_logic);
        (0, kea_1.beforeUnmount)(function () { return (0, channel_1.cancelSaga)(index); })(_logic);
    };
}
exports.saga = saga;
function workers(input) {
    return function (_logic) {
        var _a;
        var logic = _logic;
        (0, utils_1.addGetAndFetch)(logic);
        (_a = logic.workers) !== null && _a !== void 0 ? _a : (logic.workers = {});
        for (var _i = 0, _b = Object.keys(input); _i < _b.length; _i++) {
            var key = _b[_i];
            if (typeof input[key] === 'function') {
                logic.workers[key] = input[key].bind(logic);
            }
        }
    };
}
exports.workers = workers;
function takeEvery(input) {
    return function (_logic) {
        var logic = _logic;
        (0, utils_1.addGetAndFetch)(logic);
        saga(function () {
            var actionsToTake, _i, _a, key, actionKey, fn, _b, fn_1, fun;
            var _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        actionsToTake = typeof input === 'function' ? input(_logic) : input;
                        _i = 0, _a = Object.keys(actionsToTake);
                        _d.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3, 9];
                        key = _a[_i];
                        actionKey = (_c = logic.actionTypes[key]) !== null && _c !== void 0 ? _c : key;
                        fn = actionsToTake[key];
                        if (!Array.isArray(fn)) return [3, 6];
                        _b = 0, fn_1 = fn;
                        _d.label = 2;
                    case 2:
                        if (!(_b < fn_1.length)) return [3, 5];
                        fun = fn_1[_b];
                        return [4, (0, effects_1.takeEvery)(actionKey, fun.bind(logic))];
                    case 3:
                        _d.sent();
                        _d.label = 4;
                    case 4:
                        _b++;
                        return [3, 2];
                    case 5: return [3, 8];
                    case 6: return [4, (0, effects_1.takeEvery)(actionKey, fn.bind(logic))];
                    case 7:
                        _d.sent();
                        _d.label = 8;
                    case 8:
                        _i++;
                        return [3, 1];
                    case 9: return [2];
                }
            });
        })(_logic);
    };
}
exports.takeEvery = takeEvery;
function takeLatest(input) {
    return function (_logic) {
        var logic = _logic;
        (0, utils_1.addGetAndFetch)(logic);
        saga(function () {
            var actionsToTake, _i, _a, key, actionKey, fn, _b, fn_2, fun;
            var _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        actionsToTake = typeof input === 'function' ? input(_logic) : input;
                        _i = 0, _a = Object.keys(actionsToTake);
                        _d.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3, 9];
                        key = _a[_i];
                        actionKey = (_c = logic.actionTypes[key]) !== null && _c !== void 0 ? _c : key;
                        fn = actionsToTake[key];
                        if (!Array.isArray(fn)) return [3, 6];
                        _b = 0, fn_2 = fn;
                        _d.label = 2;
                    case 2:
                        if (!(_b < fn_2.length)) return [3, 5];
                        fun = fn_2[_b];
                        return [4, (0, effects_1.takeLatest)(actionKey, fun.bind(logic))];
                    case 3:
                        _d.sent();
                        _d.label = 4;
                    case 4:
                        _b++;
                        return [3, 2];
                    case 5: return [3, 8];
                    case 6: return [4, (0, effects_1.takeLatest)(actionKey, fn.bind(logic))];
                    case 7:
                        _d.sent();
                        _d.label = 8;
                    case 8:
                        _i++;
                        return [3, 1];
                    case 9: return [2];
                }
            });
        })(_logic);
    };
}
exports.takeLatest = takeLatest;
function cancelled(input) {
    return function (_logic) {
        var logic = _logic;
        (0, utils_1.addGetAndFetch)(logic);
        saga(function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, , 4, 8]);
                        _a.label = 1;
                    case 1:
                        if (!true) return [3, 3];
                        return [4, (0, effects_1.take)('wait until worker cancellation')];
                    case 2:
                        _a.sent();
                        return [3, 1];
                    case 3: return [3, 8];
                    case 4: return [4, (0, effects_1.cancelled)()];
                    case 5:
                        if (!_a.sent()) return [3, 7];
                        return [4, (0, effects_1.call)(input.bind(logic))];
                    case 6:
                        _a.sent();
                        _a.label = 7;
                    case 7: return [7];
                    case 8: return [2];
                }
            });
        })(_logic);
    };
}
exports.cancelled = cancelled;
//# sourceMappingURL=builders.js.map