"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sagaPlugin = void 0;
var redux_saga_1 = __importStar(require("redux-saga"));
var kea_1 = require("kea");
var channel_1 = require("./channel");
var builders_1 = require("./builders");
var utils_1 = require("./utils");
var sagaPlugin = function (_a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.injectGetFetchIntoEveryLogic, injectGetFetchIntoEveryLogic = _c === void 0 ? false : _c;
    return ({
        name: 'saga',
        defaults: function () { return ({
            get: undefined,
            fetch: undefined,
            workers: undefined,
            saga: undefined,
        }); },
        events: __assign(__assign({ beforeReduxStore: function (options) {
                var sagaContext = (0, kea_1.getPluginContext)('saga');
                sagaContext.sagaMiddleware = (0, redux_saga_1.default)();
                options.middleware.push(sagaContext.sagaMiddleware);
            }, afterReduxStore: function () {
                var _a;
                var sagaContext = (0, kea_1.getPluginContext)('saga');
                sagaContext.sagaTask = (_a = sagaContext.sagaMiddleware) === null || _a === void 0 ? void 0 : _a.run(channel_1.keaSaga);
            }, beforeCloseContext: function (context) {
                var _a;
                var store = (context || (0, kea_1.getContext)()).store;
                store && store.dispatch(redux_saga_1.END);
                var sagaContext = (0, kea_1.getPluginContext)('saga');
                if ((_a = sagaContext.sagaTask) === null || _a === void 0 ? void 0 : _a.isRunning()) {
                    sagaContext.sagaTask.cancel();
                }
            } }, (injectGetFetchIntoEveryLogic
            ? {
                afterLogic: function (logic) {
                    if (injectGetFetchIntoEveryLogic) {
                        (0, utils_1.addGetAndFetch)(logic);
                    }
                },
            }
            : {})), { legacyBuild: function (logic, input) {
                var _a;
                'workers' in input && input.workers && (0, builders_1.workers)(input.workers)(logic);
                'takeEvery' in input && input.takeEvery && (0, builders_1.takeEvery)(input.takeEvery)(logic);
                'takeLatest' in input && input.takeLatest && (0, builders_1.takeLatest)(input.takeLatest)(logic);
                'stop' in input && input.stop && (0, builders_1.cancelled)(input.stop)(logic);
                var sagas = __spreadArray(__spreadArray(__spreadArray([], ('start' in input && input.start ? [input.start] : []), true), ('sagas' in input && input.sagas ? input.sagas : []), true), ('connect' in input && ((_a = input.connect) === null || _a === void 0 ? void 0 : _a.sagas) ? input.connect.sagas : []), true);
                if (sagas.length > 0) {
                    for (var _i = 0, sagas_1 = sagas; _i < sagas_1.length; _i++) {
                        var s = sagas_1[_i];
                        if ('_isKea' in s) {
                            (0, kea_1.connect)(s)(logic);
                        }
                        else {
                            (0, builders_1.saga)(s)(logic);
                        }
                    }
                }
            } }),
    });
};
exports.sagaPlugin = sagaPlugin;
//# sourceMappingURL=plugin.js.map