"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addGetAndFetch = void 0;
var kea_1 = require("kea");
function addGetAndFetch(logic) {
    if (!('get' in logic) || !logic.get) {
        logic.get = function (key) { var _a; return (key ? logic.values[key] : (_a = logic.selector) === null || _a === void 0 ? void 0 : _a.call(logic, (0, kea_1.getContext)().store.getState())); };
    }
    if (!('fetch' in logic) || !logic.fetch) {
        logic.fetch = function () {
            var keys = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                keys[_i] = arguments[_i];
            }
            var results = {};
            for (var _a = 0, keys_1 = keys; _a < keys_1.length; _a++) {
                var key = keys_1[_a];
                results[key] = logic.values[key];
            }
            return results;
        };
    }
}
exports.addGetAndFetch = addGetAndFetch;
//# sourceMappingURL=utils.js.map